=== debian/changelog ===
znc (1.9.0-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:55:35 +1100

znc (1.9.0-2build2) noble; urgency=medium

  * No-change rebuild against libcurl4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:09:20 +0000

znc (1.9.0-2build1) noble; urgency=medium

  * No-change rebuild against libperl5.38t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 09 Mar 2024 18:24:06 +0000

znc (1.9.0-2) unstable; urgency=medium

  * Use argon2 for password hashing.
    Closes: #1065379

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 04 Mar 2024 11:09:56 +0100

znc (1.9.0-1) unstable; urgency=medium

  * New upstream release.
    - Add corecaps module.
  * Update debian/copyright.

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 01 Mar 2024 11:39:35 +0100
